// Qiɮ׽s边 HEXEdit
// Design by http://delphi.ktop.com.tw
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    ScrollBar1: TScrollBar;
    Image1: TImage;
    SpeedButton6: TSpeedButton;
    FindDialog1: TFindDialog;
    ReplaceDialog1: TReplaceDialog;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton5Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure ReplaceDialog1Find(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    EditData:array of record
       c:char;
       pos:integer;
    end;
    buf:array[0..255] of char;
    FileModified:boolean;
    FP:File;
    FileOpened:boolean;
    PosOff:integer;
    PosTop:integer;
    AreaType:integer;
    LastEditPos:integer;
    LastEditChar:char;
    EditMode:integer;
    function FileSave:boolean;
    function CheckModified:boolean;
    function FileOpen(FileName:string):boolean;
    function FindEdit(P:integer):integer;
    function FileSearch(str:string;MatchCase:boolean):Boolean;
    procedure ShowData;
  end;


var
  Form1: TForm1;

implementation

{$R *.DFM}
//NQiର10i(@Ӧ줸)
function HexToInt(c:char):integer;
var s:string;
begin
   s:=c;
   s:=uppercase(s);
   if (s>='0') and (s<='9') then result:=ord(c)-ord('0')
   else if (s>='A') and (s<='F') then result:=ord(s[1])-ord('A')+10
   else result:=-1;
end;
//NQi줺Xr(H$}Y)
function ChangeHEXStr(s:string):string;
var str:string;
    i:integer;
    c:char;
begin
  if copy(s,1,1)='$' then
  begin
     str:='';
     for i:=1 to (length(s)-1) div 2 do
     begin
       c:=chr(HexToInt(s[2+(i-1)*2])*16+HexToInt(s[2+(i-1)*2+1]));
       str:=str+c;
     end;
     result:=str;
  end
  else result:=s;
end;
// ˬdɮ׬O_Qק
function TForm1.CheckModified:boolean;
var mb:word;
begin
   result:=true;
   if FileModified then
   begin
     mb:=MessageDlg('Save Modified file ?',
     mtConfirmation, [mbYes, mbNo,mbCancel], 0) ;
     if mb= mrYes then
     begin
        if FileSave then
           Result:=True
        else
          Result:=False;
     end
     else if mb= mrNo then
     begin
        Result:=True;
     end
     else
     begin
        Result:=False;
     end;
   end;
end;
// X줸O_Qק,Ǧ^ק}CEditDataPosition
function TForm1.FindEdit(P:integer):integer;
var i:integer;
begin
   Result:=-1;
   for i:=0 to high(EditData) do
   begin
      if editdata[i].pos=p then
      begin
        Result:=i;
      end;
   end;
end;
// }ɮ
function TForm1.FileOpen(FileName:string):boolean;
begin
  if FileOpened then CloseFile(fp);
  result:=false;
  if FileExists(FileName) then
  begin
     SetLength(EditData,0);
     FileModified:=False;
     AreaType:=0;
     LastEditPos:=-1;
     EditMode:=0;
     AssignFile(FP,Filename);
     PosTop:=0;
     PosOff:=0;
     Reset(FP,1);
     FileOpened:=True;
     result:=true;
  end;
end;
// ܤ@
procedure TForm1.Showdata;
var i,sizes:integer;
  r:trect;
  f,ax,bx,by,x,y,cx,cy:integer;
  w,h:integer;
  str:string;
  LineStar:integer;
  // ܥk@
  procedure ShowStr(x,y:integer;str:string);
  var i,f,f2:integer; c1,c2:char; s2:string;
  begin
    i:=1;
    while i<=length(str) do
    begin
       c1:=str[i];
       if (ord(c1)>=128) and (i<length(str)) then
       begin
         c2:=str[i+1];
         f:=FindEdit(LineStar+i-1);
         f2:=FindEdit(LineStar+i);
         if (f>=0) or (f2>=0) then
           image1.Canvas.Font.color:=clRed
         else
           image1.Canvas.Font.color:=ClBlack;
         image1.Canvas.TextOut(x+(i-1)*w,y,c1+c2);
         inc(i);
       end
       else
       begin
         f:=FindEdit(LineStar+i-1);
         if (f>=0) then
           image1.Canvas.Font.color:=ClRed
         else
           image1.Canvas.Font.color:=ClBlack;
         image1.Canvas.TextOut(x+(i-1)*w,y,c1);
       end;
       inc(i);
    end;
  end;
begin
   seek(fp,PosTop);
   BlockRead(fp,buf,256,sizes);
   r.top:=0;
   r.left:=0;
   r.right:=image1.width;
   r.bottom:=image1.height;
   image1.canvas.font:=font;
   image1.canvas.Brush.color:=clWhite;
   image1.Canvas.FillRect(r);
   image1.canvas.Font.color:=ClBlack;
   w:=image1.Canvas.TextWidth('W');
   H:=image1.Canvas.TextHeight('H')+2;
   bx:=10; by:=1;
   for i:=0 to 15 do
   begin
      if i>=8 then ax:=2 else ax:=0;
      if i=8 then
        image1.Canvas.TextOut(i*w*3+bx*w,0*h,'-');
     image1.Canvas.TextOut(i*w*3+bx*w+ax*w,0,format('%2.2X',[i]));
     image1.Canvas.TextOut(16*w*3+bx*w+2*w+i*W,0,format('%1.1X',[i]));
   end;
   for i:=0 to 15 do
   begin
     x:=(PosTop+i*16) div 65536;
     y:=(PosTop+i*16) mod 65536;
     image1.Canvas.TextOut(0,(i+1)*h,format('%4.4X:%4.4X',[x,y]));
   end;
   x:=0; y:=0;
   cx:=0; cy:=0;
   ax:=0;
   str:='';
   image1.canvas.Brush.color:=clWhite;
   image1.canvas.font.color:=clBlack;
   LineStar:=PosTop;
   for i:=0 to sizes-1 do
   begin
      f:=FindEdit(PosTop+i);
      image1.canvas.font.color:=clBlack;
      if x=8 then
        image1.Canvas.TextOut(x*w*3+bx*w,(by+y)*h,'-');
      if f>=0 then
      begin
         buf[i]:=EditData[f].c;
         image1.Canvas.Font.color:=ClRed;
      end;
      if x>=8 then ax:=2 else ax:=0;
      if i=PosOff then
      begin
        cx:=x; cy:=y;
      end;
      image1.Canvas.TextOut(x*w*3+bx*w+ax*w,(by+y)*h,format('%2.2X',[ord(buf[i])]));
      if ord(buf[i])<ord(' ') then
      str:=str+'.'
      else
      str:=str+buf[i];
      x:=x+1;
      if x>=16 then
      begin
        ShowStr(16*w*3+bx*w+2*w,(by+y)*h,str);
        str:='';
        x:=0;
        LineStar:=LineStar+16;
        y:=y+1;
      end;
   end;
   if str<>'' then
   begin
      ShowStr(16*w*3+bx*w+2*w,(by+y)*h,str);
   end;
   if AreaType=0 then
   begin
     image1.Canvas.pen.color:=ClBlack;
     Image1.canvas.CopyMode:=cmDstInvert	;
     x:=cx; y:=cy;
     if x>=8 then ax:=2 else ax:=0;
     r.left:=x*w*3+bx*w+ax*w;
     r.top:=(by+y)*h;
     r.Right:=r.left+w*2;
     r.bottom:=r.top+h;
     image1.Canvas.CopyRect(r,image1.Canvas,r);
     Image1.canvas.CopyMode:=cmSrcCopy;
   end
   else
   begin
     image1.Canvas.pen.color:=ClBlack;
     image1.Canvas.pen.color:=Clwhite;
     Image1.canvas.CopyMode:=cmDstInvert	;
     x:=cx; y:=cy;
     ax:=2;
     r.left:=16*w*3+bx*w+ax*w+x*W;
     r.top:=(by+y)*h;
     r.Right:=r.left+w;
     r.bottom:=r.top+h;
     image1.Canvas.CopyRect(r,image1.Canvas,r);
     Image1.canvas.CopyMode:=cmSrcCopy;
   end;
   Application.ProcessMessages;
end;
// ɮצs
function TForm1.FileSave:boolean;
var buf:array[0..0] of char;
i,sizes:integer;
begin
   result:=True;
   for i:=0 to high(EditData) do
   begin
     seek(fp,editdata[i].pos);
     buf[0]:=editdata[i].c;
     BlockWrite(fp,buf,1,sizes);
     if sizes<>1 then result:=False;
   end;
   if Result then
   begin
     SetLength(EditData,0);
     FileModified:=False;
     SpeedButton2.Enabled:=FileModified;
     SpeedButton7.Enabled:=FileModified;
     StatusBar1.Panels[2].text:='';
     SHowData;
   end
   else ShowMessage('Save Error!');
end;

// }ɮ
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
   if CheckModified then
   if OpenDialog1.Execute then
   if FileOpen(OpenDialog1.filename) then
   begin
     SpeedButton2.Enabled:=FileModified;
     SpeedButton7.Enabled:=FileModified;
     ScrollBar1.max:=filesize(fp)-1;
     ScrollBar1.position:=PosTop+PosOff+FilePos(FP);
     StatusBar1.Panels[0].text:='';
     StatusBar1.Panels[1].text:=inttostr(ScrollBar1.position+1)+'/'+inttostr(ScrollBar1.max+1);
     StatusBar1.Panels[2].text:='';
     StatusBar1.Panels[3].text:='';
     SpeedButton8.Enabled:=FileOpened;
     SpeedButton6.Enabled:=FileOpened;
     SpeedButton3.Enabled:=FileOpened;
     SpeedButton4.Enabled:=FileOpened;
     caption:=OpenDialog1.filename;
     ShowData;
   end;
end;
// Initܼ
procedure TForm1.FormCreate(Sender: TObject);
begin
  FileModified:=False;
  SpeedButton2.Enabled:=FileModified;
  SpeedButton7.Enabled:=FileModified;
  FileOpened:=False;
  SpeedButton8.Enabled:=FileOpened;
  SpeedButton6.Enabled:=FileOpened;
  SpeedButton3.Enabled:=FileOpened;
  SpeedButton4.Enabled:=FileOpened;
  AreaType:=0;
  setlength(EditData,0);
  LastEditPos:=-1;
  EditMode:=0;
end;
// ɮצmScrollBar
procedure TForm1.ScrollBar1Change(Sender: TObject);
var p,p1,p2:integer;
begin
  if FileOpened then
  begin
    Editmode:=0;
    p:=ScrollBar1.Position;
    if (p>=PosTop) and (p<=PosTop+255) then
    begin
       PosOff:=P-PosTop;
    end
    else
    begin
      PosOff:=p mod 256;
      PosTop:=p-PosOff;
    end;
    Seek(fp,ScrollBar1.Position);
  //  ScrollBar1.position:=PosTop+PosOff+FilePos(FP);
    StatusBar1.Panels[1].text:=inttostr(ScrollBar1.position+1)+'/'+inttostr(ScrollBar1.max+1);
    Showdata;
  end;
end;
// 䱱()
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if not FileOpened Then exit;
   if key=VK_UP then
   begin
      if PosOff<16 then
      begin
        if PosTop>=16 then
        begin
           PosTop:=PosTop-16;
        end;
      end;
      if ScrollBar1.position>=16 then
      begin
        ScrollBar1.position:=ScrollBar1.position-16;
      end;
      key:=0;
   end
   else if key=VK_DOWN then
   begin
      if PosOff>255-16 then
      begin
        if PosTop<=ScrollBar1.max-16 then
        begin
           PosTop:=PosTop+16;
        end;
      end;
      if ScrollBar1.position<=ScrollBar1.max-16 then
      begin
        ScrollBar1.position:=ScrollBar1.position+16;
      end;
      key:=0;
   end
   else if key=VK_LEFT then
   begin
      if PosOff<=0 then
      begin
        if PosTop>=16 then
        begin
           PosTop:=PosTop-16;
           PosOff:=15;
        end;
      end;
      if ScrollBar1.position>=1 then
      begin
        ScrollBar1.position:=ScrollBar1.position-1;
      end;
      key:=0;
   end
   else if key=VK_RIGHT then
   begin
      if PosOff>=255 then
      begin
        if PosTop<=ScrollBar1.max-16 then
        begin
           PosTop:=PosTop+16;
           PosOff:=255-15;
        end;
      end;
      if ScrollBar1.position<=ScrollBar1.max-1 then
      begin
        ScrollBar1.position:=ScrollBar1.position+1;
      end;
      key:=0;
   end
   else if key=VK_PRIOR then
   begin
      if PosTop>=256 then
      begin
        PosTop:=PosTop-256;
      end;
      if ScrollBar1.position>=256 then
      begin
        ScrollBar1.position:=ScrollBar1.position-256;
      end;
      key:=0;
   end
   else if key=VK_NEXT then
   begin
      if PosTop<=ScrollBar1.max-256 then
      begin
        PosTop:=PosTop+256;
        if PosOff+PosTop>ScrollBar1.max then
          PosOff:=ScrollBar1.max-PosTop;
        if ScrollBar1.position>ScrollBar1.max-256 then
          ScrollBar1.position:=PosTop+PosOff;
      end;
      if ScrollBar1.position<=ScrollBar1.max-256 then
      begin
        ScrollBar1.position:=ScrollBar1.position+256;
      end;
      key:=0;
   end
   else if key=VK_HOME then
   begin
      ScrollBar1.position:=0;
      key:=0;
   end
   else if key=VK_END then
   begin
      ScrollBar1.position:=ScrollBar1.max;
      key:=0;
   end
end;
// Exit
procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  close;
end;
// eˬds
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if CheckModified then
     CanClose:=True
  else CanClose:=False;
end;
// 䱱(tab)
procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if not FileOpened Then exit;
  if key=9 then
   begin
     AreaType:=1-AreaType;
     ShowData;
     key:=0;
   end;
end;
// ɮצs
procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  if FileModified then FileSave;
end;
// 䱱(J)
procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
var f,h,k:integer;
  key2:char;
begin
  caption:=caption+key;
  if not FileOpened Then exit;
  if AreaType=0 then
  begin
     k:=HexToInt(key);
     if k>=0 then
     begin
       f:=FindEdit(ScrollBar1.Position);
       if f<0 then
       begin
          h:=High(EditData);
          if h=-1 then SetLength(EditData,1)
          else SetLength(EditData,h+1+1);
          h:=High(EditData);
          key2:=buf[PosOff];
       end
       else
       begin
         h:=f;
         key2:=EditData[h].c;
       end;
       EditData[h].pos:=ScrollBar1.Position;
       if EditMode=0 then
       begin
         key2:=chr((ord(key2) and $f) or (k shl 4));
         EditData[h].c:=key2;
         EditMode:=1;
         ShowData;
       end
       else
       begin
         key2:=chr((ord(key2) and $f0) or (k));
         EditData[h].c:=key2;
         EditMode:=0;
         if ScrollBar1.Position<ScrollBar1.max then
            ScrollBar1.Position:=ScrollBar1.Position+1;
       end;
       key:=#0;
       StatusBar1.Panels[2].text:=inttostr(high(EditData)+1)+' Byte(s) Modified';
       FileModified:=True;
       SpeedButton2.Enabled:=FileModified;
       SpeedButton7.Enabled:=FileModified;
     end;
  end
  else
  begin
     f:=FindEdit(ScrollBar1.Position);
     if f<0 then
     begin
        h:=High(EditData);
        if h=-1 then SetLength(EditData,1)
        else SetLength(EditData,h+1+1);
        h:=High(EditData);
     end
     else h:=f;
     EditData[h].pos:=ScrollBar1.Position;
     EditData[h].c:=key;
     if ScrollBar1.Position<ScrollBar1.max then
       ScrollBar1.Position:=ScrollBar1.Position+1;
     key:=#0;
     StatusBar1.Panels[2].text:=inttostr(high(EditData)+1)+' Byte(s) Modified';
     FileModified:=True;
     SpeedButton2.Enabled:=FileModified;
     SpeedButton7.Enabled:=FileModified;
  end;
end;
// Jumpܫwɮצm
procedure TForm1.SpeedButton6Click(Sender: TObject);
var str:string;
   n:integer;
begin
  str:='';
  if InputQuery('Jump','Jump Position (0..'+inttostr(ScrollBar1.max)+')',Str) then
  begin
     n:=strtointdef(str,0);
     if (n>=0) and (n<=ScrollBar1.max) then
     begin
        ScrollBar1.position:=n;
     end;
  end;
end;
//  MSwr
function TForm1.FileSearch(str:string;MatchCase:boolean):Boolean;
//const blocksize=10240; blocksize2=5120;
const blocksize=512; blocksize2=256;
var buf:array[0..blocksize-1] of char;
    i,j,sizes,star,k:integer;
    s1:string;
    f:boolean;
begin
   if not MatchCase then
      str:=Uppercase(str);
   Result:=False;
   SetLength(s1,blocksize);
   FillChar(s1[1],blocksize,#0);
   i:= scrollbar1.Position+1;
   seek(fp,i);
   f:=true;
   star:=i;
   while i<=scrollbar1.max do
   begin
      if f then
      begin
         BlockRead(fp,s1[1],BlockSize,sizes);
         f:=false;
      end
      else
      begin
        move(s1[257],s1[1],BlockSize2);
        BlockRead(fp,s1[BlockSize2+1],BlockSize2,sizes);
//        if sizes<>BlockSize2 then showmessage('err:'+inttostr(star));
        for j:=sizes+BlockSize2+1 to BlockSize do s1[j]:=#0;
      end;
      if not (frMatchCase in FindDialog1.Options) then
         s1:=Uppercase(s1);
      j:=pos(str,s1);
      if j>0 then
      begin
         scrollbar1.Position:=star+j-1;
         Result:=True;
         break;
      end;
      i:=i+sizes;
      star:=star+BlockSize2;
   end;
end;
// M
procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  FindDialog1.Execute;
end;
// M䪺ʧ@
procedure TForm1.FindDialog1Find(Sender: TObject);
var str:string;
 tp:tpoint;
begin
  StatusBar1.Panels[3].text:='Searching...'+FindDialog1.FindText;
  tp.y:=form1.top+ScrollBar1.top;
  tp.x:= FindDialog1.Position.x;
  FindDialog1.Position:=tp;
  str:=ChangeHEXStr(FindDialog1.FindText);
  if not FileSearch(str,frMatchCase in FindDialog1.options) then
      ShowMessage('Not Found');
  StatusBar1.Panels[3].text:='';
end;
// m
procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  ReplaceDialog1.Execute;
end;
// mʧ@
procedure TForm1.ReplaceDialog1Replace(Sender: TObject);
var str:string;
 tp:tpoint;
 f:boolean;
 f2,h,i:integer;
 key:char;
 rs:string;
begin
  StatusBar1.Panels[3].text:='Replacing...'+ReplaceDialog1.FindText+' '+ReplaceDialog1.ReplaceText;
  rs:=ChangeHEXStr(ReplaceDialog1.ReplaceText);
  tp.y:=form1.top+ScrollBar1.top;
  tp.x:= ReplaceDialog1.Position.x;
  ReplaceDialog1.Position:=tp;
    str:=ChangeHEXStr(ReplaceDialog1.FindText);
   begin
     f:=false;
    while FileSearch(str,frMatchCase in ReplaceDialog1.options) do
    begin
      f:=true;
      for i:=1 to length(rs) do
      begin
        key:=rs[i];
        if ScrollBar1.Position+i-1>ScrollBar1.max then break;
     f2:=FindEdit(ScrollBar1.Position+i-1);
     if f2<0 then
     begin
        h:=High(EditData);
        if h=-1 then SetLength(EditData,1)
        else SetLength(EditData,h+1+1);
        h:=High(EditData);
     end
     else h:=f2;
     EditData[h].pos:=ScrollBar1.Position+i-1;
     EditData[h].c:=key;
        end;
     if ScrollBar1.Position+length(rs)<ScrollBar1.max then
       ScrollBar1.Position:=ScrollBar1.Position+length(rs)
     else
       ScrollBar1.Position:=ScrollBar1.max;
     StatusBar1.Panels[2].text:=inttostr(high(EditData)+1)+' Byte(s) Modified';
     FileModified:=True;
     SpeedButton2.Enabled:=FileModified;
     SpeedButton7.Enabled:=FileModified;
     if not (frReplaceAll in ReplaceDialog1.Options) then break;
    end;
    if f then
    begin
     if not (frReplaceAll in ReplaceDialog1.Options) then
     ShowMessage('String Replaced')
     else
     ShowMessage('All Replaced')
    end
    else
      ShowMessage('Not Found');
   end;
  StatusBar1.Panels[3].text:='';
end;
// M䪺ʧ@
procedure TForm1.ReplaceDialog1Find(Sender: TObject);
var str:string;
 tp:tpoint;
begin
  StatusBar1.Panels[3].text:='Searching...'+ReplaceDialog1.FindText;
  tp.y:=form1.top+ScrollBar1.top;
  tp.x:= ReplaceDialog1.Position.x;
  ReplaceDialog1.Position:=tp;
  str:=ChangeHEXStr(ReplaceDialog1.FindText);
  if not FileSearch(str,frMatchCase in ReplaceDialog1.options) then
    ShowMessage('Not Found');
  StatusBar1.Panels[3].text:='';
end;
// ק
procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
  SetLength(EditData,0);
  FileModified:=False;
  SpeedButton2.Enabled:=FileModified;
  SpeedButton7.Enabled:=FileModified;
  StatusBar1.Panels[2].text:='';
  showdata;
end;
// 
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if FileOpened then CloseFile(fp);
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
var str:string;
  i:integer;
  c:char;
begin
  str:='';
  if InputQuery('Input','Input String',Str) then
  begin
     for i:=1 to length(str) do
     begin
       c:=str[i];
       FormKeyPress(sender,c);
     end;
  end;
end;

end.
